import { Key, Selector } from '../ServiceCollection';
import { ILifetime } from '../Lifetime';
import { IServiceProvider } from './IServiceProvider';
export interface IDependencyTracker {
    lastSingleton?: Key<any>;
    readonly depth: number;
    enter(key: Key<any>): void;
    leave(key: Key<any>): void;
}
export declare class DependencyTracker implements IDependencyTracker {
    private readonly lookup;
    private readonly ordered;
    get depth(): number;
    enter(key: Key<any>): void;
    leave(key: Key<any>): void;
}
export declare type ProviderScope = Record<Key<any>, any>;
export declare class ScopedContext<E> implements IServiceProvider<E> {
    readonly lifetimes: Record<Key<E>, ILifetime<any, E>>;
    readonly proxy: E;
    readonly dependencyTracker: IDependencyTracker;
    readonly scope: ProviderScope;
    constructor(lifetimes: Record<Key<E>, ILifetime<any, E>>);
    provide<T>(selector: Selector<T, E>): T;
}
